//+------------------------------------------------------------------+
//|                                                       TimeEA.mq4 |
//|                                                          Enotrek |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Enotrek"
#property link      ""

extern int     MagicNumber       = 12333321;
extern int     Slippage          = 5;
extern int     Buy0_Sell1        = 0;
extern string  InTime            = "12:00";
extern string  OutTime           = "12:30";
extern double  Lots              = 0.1;
extern int     Stoploss          = 50;

bool
   TradeAllowed = true;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int
      Ticket,
      dg,
      mt;
   bool
      ServerAnswer;
   double
      pt;
      
   dg = Digits;
 
   if(dg==3 || dg==5){
      pt=Point*10;
      mt=10;
   }
   else{
      pt=Point;
      mt=1;
   }
   
      
   
   double 
      Time.Start  = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE) +" "+InTime+":00"),
      Time.End    = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE) +" "+OutTime+":00");
   
   if(TimeCurrent() >= Time.Start && TimeCurrent() < Time.End && TradeAllowed){   // Start Trade
   
      if(Buy0_Sell1 == OP_BUY){     // OpenBuy
         RefreshRates();
         Ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage*mt,Ask-Stoploss*pt,0,"TimeEA",MagicNumber,0,CLR_NONE);
         if(Ticket <= 0)
            Print("Error occured at open: ", GetLastError());
         
      }
      if(Buy0_Sell1 == OP_SELL){     // OpenSell
         RefreshRates();
         Ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage*mt,Bid-Stoploss*pt,0,"TimeEA",MagicNumber,0,CLR_NONE);
         if(Ticket <= 0)
            Print("Error occured at open: ", GetLastError());
         
      }
      
      TradeAllowed = false;   
   }
   if(TimeCurrent() >= Time.End){                                 // EndTrade
   
      for(int i=OrdersTotal()-1; i>=0; i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            if(OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol()){
               if(OrderType() == OP_BUY){  // Close Buy
                  Ticket = OrderTicket();
                  ServerAnswer = OrderClose(Ticket,OrderLots(),Bid,Slippage*mt,CLR_NONE);
                  if(!ServerAnswer){
                     Print("Error occured at close: ", GetLastError());   
                  }
               }
               if(OrderType() == OP_SELL){  // Close Sell
                  Ticket = OrderTicket();
                  ServerAnswer = OrderClose(Ticket,OrderLots(),Ask,Slippage*mt,CLR_NONE);
                  if(!ServerAnswer){
                     Print("Error occured at close: ", GetLastError());   
                  }
               }
            }
      }
      
      
      TradeAllowed = true;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+